export interface BrCodeJson {
    payload_version: number;
    initiation_method?: number;
    merchant_account_information?: string;
    merchant_information: Array<{
        id: number;
        info: Array<{
            id: number;
            info: string;
        }>;
    }>;
    merchant_category_code: number;
    merchant_name: string;
    merchant_city: string;
    postal_code?: string;
    convenience?: String;
    convenience_fee_fixed?: String;
    convenience_fee_percentage?: String;
    currency: string;
    amount?: number;
    country_code: string;
    field_template: Array<{
        reference_label: string;
    }>;
    crc1610: string;
    templates?: Array<{
        id: number;
        info: Array<{
            id: number;
            info: string;
        }>;
    }>;
}
export declare function jsonToBrcode(json: BrCodeJson): string;
export declare function brcodeToJson(code: string): BrCodeJson;
export declare function brcodeIsPix(code: String): boolean;
export declare function jsonIsPix(json: BrCodeJson): boolean;
export declare function crc16Ccitt(message: string): string;
export declare function getJsonTransactionId(json: BrCodeJson): String;
export declare function getBrcodeTransactionId(code: String): String;
export declare function getJsonAliases(json: BrCodeJson): Array<String>;
export declare function getBrcodeAliases(code: String): Array<String>;
export declare function getJsonMessages(json: BrCodeJson): Array<String>;
export declare function getBrcodeMessages(code: String): Array<String>;
export declare function jsonToSvgString(json: BrCodeJson): String;
export declare function brcodeToSvgString(code: String): String;
export declare function jsonToSvgFile(json: BrCodeJson, path: String): void;
export declare function brcodeToSvgFile(code: String, path: String): void;
