"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var brcode = __importStar(require("./index"));
var code = "00020104141234567890123426580014BR.GOV.BCB.PIX0136123e4567-e12b-12d1-a456-42665544000027300012BR.COM.OUTRO011001234567895204000053039865406123.455802BR5917NOME DO RECEBEDOR6008BRASILIA61087007490062190515RP12345678-201980390012BR.COM.OUTRO01190123.ABCD.3456.WXYZ6304AD38";
var unchecked_code = "00020104141234567890123426580014BR.GOV.BCB.PIX0136123e4567-e12b-12d1-a456-42665544000027300012BR.COM.OUTRO011001234567895204000053039865406123.455802BR5917NOME DO RECEBEDOR6008BRASILIA61087007490062190515RP12345678-201980390012BR.COM.OUTRO01190123.ABCD.3456.WXYZ6304";
var json = {
    payload_version: 1,
    merchant_account_information: "12345678901234",
    merchant_information: [
        { id: 26, info: [
                { id: 0, info: "BR.GOV.BCB.PIX" },
                { id: 1, info: "123e4567-e12b-12d1-a456-426655440000" }
            ] },
        { id: 27, info: [
                { id: 0, info: "BR.COM.OUTRO" },
                { id: 1, info: "0123456789" }
            ] }
    ],
    merchant_category_code: 0,
    merchant_name: "NOME DO RECEBEDOR",
    merchant_city: "BRASILIA",
    postal_code: "70074900",
    currency: "986",
    amount: 123.45,
    country_code: "BR",
    field_template: [{ reference_label: "RP12345678-2019" }],
    crc1610: "AD38",
    templates: [
        { id: 80, info: [
                { id: 0, info: "BR.COM.OUTRO" },
                { id: 1, info: "0123.ABCD.3456.WXYZ" }
            ] }
    ]
};
var notBrcodeJson = {
    payload_version: 1,
    merchant_account_information: "12345678901234",
    merchant_information: [
        { id: 26, info: [
                { id: 0, info: "BR.USA.FR.FIX" },
                { id: 1, info: "123e4567-e12b-12d1-a456-426655440000" }
            ] },
        { id: 27, info: [
                { id: 0, info: "BR.COM.OUTRO" },
                { id: 1, info: "0123456789" }
            ] }
    ],
    merchant_category_code: 0,
    merchant_name: "NOME DO RECEBEDOR",
    merchant_city: "BRASILIA",
    postal_code: "70074900",
    currency: "986",
    amount: 123.45,
    country_code: "BR",
    field_template: [{ reference_label: "RP12345678-2019" }],
    crc1610: "AD38",
    templates: [
        { id: 80, info: [
                { id: 0, info: "BR.COM.OUTRO" },
                { id: 1, info: "0123.ABCD.3456.WXYZ" }
            ] }
    ]
};
var jsonWithMessage = {
    payload_version: 1,
    merchant_account_information: "12345678901234",
    merchant_information: [
        { id: 26, info: [
                { id: 0, info: "BR.GOV.BCB.PIX" },
                { id: 1, info: "123e4567-e12b-12d1-a456-426655440000" },
                { id: 2, info: "This is a message" }
            ] },
        { id: 27, info: [
                { id: 0, info: "BR.COM.OUTRO" },
                { id: 1, info: "0123456789" }
            ] },
        { id: 28, info: [
                { id: 0, info: "BR.GOV.BCB.PIX" },
                { id: 1, info: "555199998877" },
                { id: 2, info: "This is another message" }
            ] },
    ],
    merchant_category_code: 0,
    merchant_name: "NOME DO RECEBEDOR",
    merchant_city: "BRASILIA",
    postal_code: "70074900",
    currency: "986",
    amount: 123.45,
    country_code: "BR",
    field_template: [{ reference_label: "RP12345678-2019" }],
    crc1610: "AD38",
    templates: [
        { id: 80, info: [
                { id: 0, info: "BR.COM.OUTRO" },
                { id: 1, info: "0123.ABCD.3456.WXYZ" }
            ] }
    ]
};
test('Parses and Emit BR Codes', function () {
    expect(brcode.brcodeToJson(code)).toEqual(json);
    expect(brcode.jsonToBrcode(json)).toEqual(code);
});
test('Crc16 CCITT', function () {
    expect(brcode.crc16Ccitt("biscuit")).toEqual("B8CE");
    expect(brcode.crc16Ccitt(unchecked_code)).toEqual("AD38");
});
test('Code and json are pix', function () {
    expect(brcode.brcodeIsPix(code)).toBeTruthy();
    expect(brcode.jsonIsPix(json)).toBeTruthy();
    expect(brcode.jsonIsPix(notBrcodeJson)).toBeFalsy();
});
test('Get code and json transaction id', function () {
    expect(brcode.getBrcodeTransactionId(code)).toEqual("RP12345678-2019");
    expect(brcode.getJsonTransactionId(json)).toEqual("RP12345678-2019");
});
test('Get pix code and json aliases', function () {
    expect(brcode.getBrcodeAliases(code)).toEqual(["123e4567-e12b-12d1-a456-426655440000"]);
    expect(brcode.getJsonAliases(json)).toEqual(["123e4567-e12b-12d1-a456-426655440000"]);
    expect(brcode.getJsonAliases(jsonWithMessage)).toEqual(["123e4567-e12b-12d1-a456-426655440000", "555199998877"]);
});
test('Get pix code and json messages', function () {
    expect(brcode.getBrcodeMessages(code)).toEqual([]);
    expect(brcode.getJsonMessages(jsonWithMessage)).toEqual(["This is a message", "This is another message"]);
});
test('Can generate svg', function () {
    expect(brcode.jsonToSvgString(json)).toContain('<svg');
});
